/**
 * goIRC (C)opyright 2007 Sebastian Kasparek
 *
 * ircparser.cpp - parse the irc protocol
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef IRCPARSER_H
#define IRCPARSER_H

#include <iostream>
#include <map>
#include <vector>

#include <util/regexp.h>
#include <util/string.h>

class IrcMessage
{
public:
	os::String m_cLine;
	os::String m_cPrefix;
	os::String m_cCommand;
	os::String m_cParams;
	os::String m_cSender;
	os::String m_cUser;
	os::String m_cHost;
	std::vector<os::String> m_cVectorParams;
};

class IrcParser
{
public:
	IrcParser();
	~IrcParser();
	IrcMessage ParseLine( os::String cLine );

private:
	class MyPrivate;
	MyPrivate* my;
};

#endif
