/**
 * goIRC (C)opyright 2007 Sebastian Kasparek
 *
 * socket.h - more information is in the doc/SocketReadMe.txt file
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details. 
 *
 * You should have received a copy of the GNU Library General Public 
 * License along with this library; if not, write to the Free 
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

#ifndef SOCKET_H
#define SOCKET_H

#include <iostream>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>

#include <util/application.h>
#include <util/looper.h>
#include <util/message.h>
#include <util/messenger.h>
#include <util/string.h>

// messages
enum
{
	M_SOCKET_CONNECT   = 100,
	M_SOCKET_CONNECTED = 101,
	M_SOCKET_SEND      = 102,
	M_SOCKET_SENT      = 103,
	M_SOCKET_RECEIVED  = 104,
	M_SOCKET_ERROR     = 105,
	M_SOCKET_INFO      = 106
};

// error numbers
enum
{
	M_SOCKETERROR_DEAD				= 110,
	M_SOCKETERROR_COULDNOTOPEN		= 111,
	M_SOCKETERROR_SERVERNOTFOUND	= 112,
	M_SOCKETERROR_COULDNOTCONNECT	= 113,
	M_SOCKETERROR_COULDNOTWRITE		= 114,
	M_SOCKETERROR_NOTALLWRITTEN		= 115,
	M_SOCKETERROR_SELECTFAILED		= 116
};

class SocketThread : public os::Looper
{
public:
	SocketThread();
	virtual ~SocketThread();
	virtual void HandleMessage( os::Message* pcMessage );
	virtual bool Idle();
	virtual bool OkToQuit();

private:
	class MyPrivate;
	MyPrivate* my;
};

#endif
